#ifndef __BLEND2CS_BLENDERTYPES_H__
#define __BLEND2CS_BLENDERTYPES_H__

namespace dna
{

// reference: source/blender/makesdna/DNA_object_types.h
/* type */
#define OB_EMPTY                0
#define OB_MESH                 1
#define OB_CURVE                2
#define OB_SURF                 3
#define OB_FONT                 4
#define OB_MBALL                5
                                                                                
#define OB_LAMP                 10
#define OB_CAMERA               11
                                                                                
#define OB_IKA                  20
#define OB_WAVE                 21
#define OB_LATTICE              22
                                                                                
/* 23 and 24 are for life and sector (old file compat.) */
#define OB_ARMATURE             25
    
// reference: source/blender/makesdna/DNA_property_types.h
/* property->type */
#define PROP_BOOL               0
#define PROP_INT                1
#define PROP_FLOAT              2
#define PROP_STRING             3
#define PROP_VECTOR             4
#define PROP_TIME               5

/* reference source/blender/makesdna/DNA_mesh_types.h */

#define TF_DYNAMIC              1
/* #define TF_INVISIBLE 2 */
#define TF_TEX                  4
#define TF_SHAREDVERT   	8
#define TF_LIGHT                16
                                                                                
#define TF_SHAREDCOL    	64
#define TF_TILES                128
#define TF_BILLBOARD    	256
#define TF_TWOSIDE              512
#define TF_INVISIBLE    	1024
                                                                                
#define TF_OBCOL                2048
#define TF_BILLBOARD2           4096    /* with Z axis constraint */
#define TF_SHADOW               8192
#define TF_BMFONT               16384
    
} // end of namespace dna

#endif
