#include <config.h>

#include <iostream>

#include "blendparser.h"
#include "structure.h"
#include "error.h"

namespace dna
{

BlendParser::BlendParser(const char* filename)
{
    blfile = BLOpenFile (filename);
    if (!blfile)
	throw Error("unable to open file \"%s\"", filename);

    if (BLParseFile(blfile) != 0)
	throw Error("error while parsing file \"%s\"", filename);
}

BlendParser::~BlendParser()
{
    BLCloseFile(blfile);
}

Structure BlendParser::getTopLevelStructure()
{
    return Structure(blfile->struct_head);
}

void BlendParser::printStructure()
{
    BLPrintStructs(blfile);
}

} // end of namespace dna

