#ifndef __BLEND2CS_BLENDPARSER_H__
#define __BLEND2CS_BLENDPARSER_H__

#include <iostream>
#include "structure.h"

namespace dna
{

/**
 * This class is responsible for parsing .blend files. It's mainly a wrapper
 * around the C parser files from blender.
 */
class BlendParser
{
public:
    BlendParser(const char* filename);
    ~BlendParser();

    /** Debug command: prints the all structures in the file */
    void printStructure();

    /** returns the top level structure of the file */
    Structure getTopLevelStructure();

private:
    BLFile* blfile;
};

} // end of namespace dna

#endif
