#include <config.h>

#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#include "error.h"

namespace dna
{

Error::Error (const char* msg, ...) throw()
{
  va_list arg;
  va_start (arg, msg);

  message = new char[1024];
  vsnprintf (message, 1024, msg, arg);

  va_end (arg);
}

Error::Error (const Error& error) throw()
    : std::exception(error)
{
  message = new char[strlen(error.message)+1];
  strcpy(message, error.message);
}

Error::~Error () throw()
{
  delete[] message;
}

const char* Error::what() const throw()
{
  return message;
}

} // end of namespace dna

