#ifndef __BLEND2CS_VARIABLE_H__
#define __BLEND2CS_VARIABLE_H__

#include <string>
#include <stdio.h>
#include "dna/btypes.h"
#include "dna/bfile.h"
#include "dna/bdata.h"
#include "dna/bparse.h"

#include "structure.h"

namespace dna
{

class Structure;
class ListIterator;

/**
 * This class is a c++ wrapper around the BData structure
 */
class Variable
{
public:
    Variable(BLData* data);
    ~Variable();

    const char* getName() const;

    /** returns number of values in the variable */
    int getLength() const;
    
    const char* getValueString() const;
    // some things like the properties use a strange way to encode strings...
    const char* getValueInternalString() const;
    char getValueChar(int num = 0) const;
    short getValueShort(int num = 0) const;
    unsigned short Variable::getValueUShort(int num=0) const;
    int getValueInt(int num = 0) const;
    float getValueFloat(int num = 0) const;
    Structure getValueStructure(int num = 0) const;
    ListIterator getValueListIterator(int num = 0) const;

private:
    BLData* data;
};

} // end of namespace dna

#endif

