#ifndef __BLEND2CS_ITERATOR_H__
#define __BLEND2CS_ITERATOR_H__

namespace blend2cs
{

// transforms a STL iterator to an easier to use java-like one
template<class Container>
class Iterator
{
public:
    Iterator(const Container& container)
    {
	i = container.begin();
	end = container.end();
    }

    bool hasNext()
    { return i != end; }
    
protected:
    typename Container::const_iterator i;
    typename Container::const_iterator end;
};

}

#endif
