#ifndef __BLEND2CS_MAPITERATOR_H__
#define __BLEND2CS_MAPITERATOR_H__

#include <map>
#include "iterator.h"

namespace blend2cs
{

template<class T1, class T2>
class MapIterator : public Iterator< std::map<T1, T2> >
{
public:
    MapIterator(const std::map<T1, T2>& container)
	: Iterator< std::map<T1, T2> >(container)
    { }

    const T2& next()
    { return (this->i++)->second; }
};

template<class T1, class T2>
class MultiMapIterator : public Iterator<std::multimap<T1, T2> >
{
public:
    MultiMapIterator(const std::multimap<T1, T2>& container)
        : Iterator<std::multimap<T1, T2> > (container)
    { }

    const T2& next()
    { return (this->i++)->second; }
};

} // end of namespace blend2cs

#endif
