#ifndef __BLEND2CS_MESH_H__
#define __BLEND2CS_MESH_H__

#include <string>
#include <dna++/structure.h>
#include "meshflags.h"

namespace blend2cs
{

class XmlWriter;

class Mesh
{
public:
    virtual ~Mesh();

    virtual const char* getMeshFactoryName() const = 0;
    virtual const char* getMeshPluginName() const = 0;
    virtual void write(XmlWriter& xml) const = 0;

    virtual dna::Structure getStructure() const = 0;

    const std::string& getName() const
    { return name; }
    void setName(const std::string& newname)
    { name = newname; }

    /** increment use count, this will usually lead in factories being written
     * */
    void incUseCount()
    { usecount++; }
    int getUseCount() const
    { return usecount; }

    const MeshFlags& getFlags() const
    { return flags; }

    virtual bool supportFactory() const = 0;

    void writeMixMode(XmlWriter& xml) const;
    
protected:
    Mesh();

    MeshFlags flags;
    std::string name;
    int usecount;
};


} // end of namespace blend2cs

#endif

