#ifndef __BLEND2CS_PROPERTY_H__
#define __BLEND2CS_PROPERTY_H__

#include <string>
#include <dna++/structure.h>

namespace blend2cs
{

class Property
{
public:
    Property(dna::Structure structure);
    ~Property();

    const std::string& getName() const
    { return name; }
    const std::string& getValue() const
    { return value; }

    bool getValueBool() const;
    float getValueFloat() const { return float_value; }
    int getValueInt() const { return int_value; }

private:
    void parseProperty();
    
    std::string name;
    std::string value;
    float float_value;
    int int_value;
    dna::Structure structure;
};

}

#endif
