#include <config.h>

#include "sector.h"

namespace blend2cs
{

Sector::Sector(const char* newname)
    : name(newname), settings(0)
{
}

Sector::~Sector()
{
    ObjectIterator i = getObjectIterator();
    while (i.hasNext())
	delete i.next();
    delete settings;
}

const std::string& Sector::getName() const
{
    return name;
}

Object* Sector::getObject(const dna::Structure& structure) const
{
    // try to find existing an object
    std::map<dna::Structure, Object*>::const_iterator i
	= objects.find(structure);

    if (i == objects.end())
	return 0;
	
    return i->second;
}

void Sector::addObject(Object* object)
{
    objects.insert (std::make_pair(object->getStructure(), object));
}

Sector::ObjectIterator Sector::getObjectIterator() const
{
    return ObjectIterator(objects);
}

} // end of namespace blend2cs
