#ifndef __BLEND2CS_SECTOR_H__
#define __BLEND2CS_SECTOR_H__

#include <map>
#include <string>
#include <dna++/structure.h>

#include "object.h"
#include "mapiterator.h"
#include "sectorsettings.h"

namespace blend2cs
{

/** Container for a CS sector. This class will be constructed during phase 1 of
 * the blender file parsing
 */
class Sector
{
public:
    Sector(const char* name);
    ~Sector();

    const std::string& getName() const;

    /** return object for the given Structure.
     */
    Object* getObject(const dna::Structure& structure) const;

    void addObject(Object* object);

    typedef MapIterator<dna::Structure, Object*> ObjectIterator;
    ObjectIterator getObjectIterator() const;

    void setSettings(SectorSettings* newsettings)
    { settings = newsettings; }
    const SectorSettings* getSettings() const
    { return settings; }

protected:
    std::map<dna::Structure, Object*> objects;

private:
    std::string name;
    SectorSettings* settings;
};

} // end of namespace blend2cs

#endif

