#ifndef __BLEND2CS_SECTORSETTINGS_H__
#define __BLEND2CS_SECTORSETTINGS_H__

#include <dna++/structure.h>
#include "property.h"
#include "vector3d.h"

namespace blend2cs
{

/** This class holds settings for CS sectors */
class SectorSettings
{
public:
    SectorSettings(dna::Structure settingsobject);
    ~SectorSettings();

    float getFogDensity() const
    { return fogdensity; }

    const Vector3D& getFogColor() const
    { return fogcolor; }

    const std::string& getCuller() const
    { return culler; }

private:
    void parseSettings(dna::Structure settingsobject);
    bool parseProperty(const Property* property);

    void parseBoolProperty(const Property* property, bool& var);

    Vector3D fogcolor;
    float fogdensity;
    std::string culler;
};

} // end of namespace blend2cs

#endif

