#ifndef __BLEND2CS_VECTOR2D_H__
#define __BLEND2CS_VECTOR2D_H__

#include <string>

namespace blend2cs
{

class Vector2D
{
public:
    Vector2D(float x=0, float y=0);
    ~Vector2D();

    void set(float newx, float newy)
    {
	x = newx;
	y = newy;
    }

    void setX(float newx)
    { x = newx; }
    void setY(float newy)
    { y = newy; }

    float getX() const
    { return x; }
    float getY() const
    { return y; }

    void operator += (const Vector2D& other)
    { x += other.x; y += other.y; }
    void operator -= (const Vector2D& other)
    { x -= other.x; y -= other.y; }

    inline friend Vector2D operator-(const Vector2D& v1, const Vector2D& v2)
    { return Vector2D(v1.x-v2.x, v1.y-v2.y); }
    inline friend Vector2D operator+(const Vector2D& v1, const Vector2D& v2)
    { return Vector2D(v1.x+v2.x, v1.y+v2.y); }
    inline friend float operator*(const Vector2D& v1, const Vector2D& v2)
    { return v1.x*v2.x + v1.y*v2.y; }

    void scale(const Vector2D& other)
    { x *= other.x; y *= other.y; }

    bool operator == (const Vector2D& other) const
    { return x == other.x && y == other.y; }

    bool operator != (const Vector2D& other) const
    { return ! (*this == other); }

private:
    float x,y;
};

}

#endif

