#include <config.h>

#include <stdio.h>

#include "vector3d.h"
#include "xmlwriter.h"
#include "dna++/error.h"

namespace blend2cs
{

Vector3D::Vector3D(float newx, float newy, float newz)
  : x(newx), y(newy), z(newz), fa(3)                                        
{
}

Vector3D::~Vector3D()
{
}

void Vector3D::scanString(const char* string)
{
    float tx, ty, tz;
    if (sscanf(string, "%f,%f,%f", &tx, &ty, &tz) != 3)
	throw dna::Error ("couldn't parse vector string");
    
    x=tx; y=ty; z=tz;
}

void Vector3D::write(XmlWriter& xml, const char* name) const
{
    xml.writeTag(name);
    xml.writeAttribute("x", x);
    xml.writeAttribute("y", y);
    xml.writeAttribute("z", z);
}

} // end of namespace blend2cs
