#ifndef __BLEND2CS_WORLDSETTINGS_H__
#define __BLEND2CS_WORLDSETTINGS_H__

#include <dna++/structure.h>
#include "property.h"
#include "vector3d.h"

namespace blend2cs
{

class WorldSettings
{
public:
    WorldSettings(dna::Structure structure);
    ~WorldSettings();

    bool getClearZBuf() const
    { return clearzbuf; }

    bool getClearScreen() const
    { return clearscreen; }

    bool getThingStatic() const
    { return thingstatic; }

    bool getGenmeshStatic() const
    { return genmeshstatic; }

    const Vector3D& getAmbient() const
    { return ambient; }
    bool isAmbientSet() const
    { return ambient_set; }

    const std::string& getTexturePath() const
    { return texturepath; }

    const std::string& getTerrainPath() const
    { return terrainpath; }

    const std::string& getRenderLoop() const
    { return renderloop; }

    bool getGlobalRenderloop() const
    { return global_renderloop; }

private:
    void parseSettings(dna::Structure structure);
    bool parseProperty(const Property* property);

    void parseBoolProperty(const Property* property, bool& var); 

    bool clearzbuf, clearscreen;
    bool thingstatic, genmeshstatic;
    Vector3D ambient;
    bool ambient_set;
    std::string texturepath;
    std::string terrainpath;
    std::string renderloop;
    bool global_renderloop;
};

} // end of namespace blend2cs

#endif

