#ifndef BLENDCONV_H
#define BLENDCONV_H

#include <string>
#include <vector>
#include <set> 

/**
 * This represents a 3 dimensional vector
 */
struct Vector {
  double X[3];
};

/**
 * This structure represents a DNA structure member
 * in a more conveniently accessible form
 */
struct Variable {
  int typeID;
  int length;
  std::string type;
  std::string name;
  std::vector<float> floatValue;
  char charValue;
  std::vector<short> shortValue;
  std::vector<int> intValue;
  unsigned long pointerValue;
  std::string stringValue;
};

/**
 * This represents a full DNA structure
 */
//struct Structure {
//  unsigned long ID;
//  std::string name;
//  std::vector<Variable> variables;
//};

//extern std::vector<Structure> structures;

char *getString(unsigned int id);
Variable FindVariable(unsigned int id, std::string name);
unsigned int FindStructure(unsigned int id, bool followLinks=true);
unsigned int FindFirstStructure();
unsigned int FindNextStructure(unsigned int id, bool followLinks=true);
std::string GetStructureName(unsigned int id);

#endif
