#ifndef LEVEL_H
#define LEVEL_H

#include <fstream>
#include <vector>
#include <set>

#include "mesh.h"
#include "light.h"
#include "texture.h"

class Level {
 public:
  void BuildLevel(std::set<Mesh, NodeCmp<Mesh> > *meshes, 
		  std::set<Light,NodeCmp<Light> > *lights,
		  BObjectContainer *instances);

  void Write(const char *filename, Textures *textures);

 protected:
  std::set<Mesh, NodeCmp<Mesh> > *meshes;
  std::set<Light,NodeCmp<Light> > *lights;
  BObjectContainer *instances;

};

#endif
