#include <iostream>
#include <fstream>

#include "light.h"
#include "blendconv.h"

void Light::Extract(int lampID)
{
  Variable temp;

  Node::Extract(lampID);

  // Read color of light source:
  temp=FindVariable(lampID,"r");
  color.X[0]=temp.floatValue[0];
  temp=FindVariable(lampID,"g");
  color.X[1]=temp.floatValue[0];
  temp=FindVariable(lampID,"b");
  color.X[2]=temp.floatValue[0];
  temp=FindVariable(lampID,"dist");
  radius=temp.floatValue[0];

  // Calculate location of light source:
  /*  for(int i=0;i<3;i++) {
    location.X[i]=translation.X[i];
  }
  // we need to rotate the light by -90 degrees along z axis (engine coord system requirement):
  double swap=location.X[1];
  location.X[1]=location.X[2];
  location.X[2]=swap; */
}

void Light::Write(std::ofstream &output, int type)
{
  //  output << "    <light>" << std::endl;
  //  output << "      <center x=\"" << location.X[0] << "\" y=\"" << location.X[1] << "\" z=\"" << location.X[2] << "\"/>" << std::endl;
  output << "      <radius>" << radius << "</radius>" << std::endl;
  output << "      <color red=\"" << color.X[0] << "\" green=\"" << color.X[1] << "\" blue=\"" << color.X[2] << "\"/>" << std::endl;
  //  output << "    </light>" << std::endl;
}
