#include "blendobj.h"
#include "texture.h"

enum btransparencyType { transp_opaque, transp_add, transp_alpha};
struct FaceMode {   // This may not be correct on big-endian machines 
  // flags giving the characteristics of the face.  On my Intel machine:
  //     1 : Use face for Collision detection.
  //     4 : Render face with texture.
  //   256 : Face is halo, it is always perpendicular to the camera.
  //   512 : face is double sided
  //  1024 : face is invisible.  not sure the point of this...
  //  4096 : face is a billboard: faces camera, with up axis 
  //         constrained to be constant
  // 16384 : face contains text.  

  unsigned  collide:       1; 
  unsigned  dunno1:        1;
  unsigned  texture:       1;
  unsigned  dunno2:        5;
  unsigned  halo:          1;
  unsigned  double_sided:  1;
  unsigned  invisible:     1;
  unsigned  dunno3:        1;
  unsigned  billboard:     1;
  unsigned  dunno4:        1;
  unsigned  text:          1;
} ;

class Poly {
 public:

  void WriteThing(std::ofstream &output,PropertyMap &pm, Textures *tx);
  void Poly::WriteThingSide(std::ofstream &output, PropertyMap &pm,
			    Textures *tx, int side);
  int Vertices[3];
  double UV[3][2];
  int textureID;   // The ID of the texture that's mapped on this polygon.
  bool isPortal; // boolean indicating if this polygon is a portal.
  btransparencyType transp;  // Transparency of the face.
  union {
    unsigned short fm;   // use for assigning from the blender file
    FaceMode ms;  // The blender face mode.  This is a bunch of OR'ed 
  } faceMode;

};
