#ifndef SPRITE_H
#define SPRITE_H

#include <fstream>
#include <vector>
#include <string>

#include "mesh.h"
#include "blendobj.h"
#include "texture.h"

class Sprite : public BlenderObject {
 public:
  std::string meshName;

  void Extract(int objectIndex, int meshID, Textures *textures);

  void Write(std::ofstream &output);

 protected:
  void ApplyTransformation();
  void ReduceData();

  std::vector<Vector> Vertices;
  std::vector<Poly> Polys;

  std::string textureFile;
  std::string textureName;

  Textures *textures;
};



#endif
