#include <iostream>
#include <fstream>

#include "texture.h"

void Textures::Add(std::string textureFile)
{
  unsigned int i;

  textureFile=StripPath(textureFile);

  for(i=0;i<textureFiles.size();i++) {
    if(textureFiles[i]==textureFile) {
      return;
    }
  }

  std::cout << "Adding file to textures list: " << textureFile << std::endl;

  textureFiles.push_back(textureFile);
}

std::string Textures::GetName(int ID)
{  // Returns the name of a texture given its ID.  Inverse of next function.
  return textureFiles[ID];  
}

int Textures::GetID(std::string textureFile)
{
  unsigned int i;

  textureFile=StripPath(textureFile);

  for(i=0;i<textureFiles.size();i++) {
    if(textureFile==textureFiles[i]) 
      return i;
  }

  std::cerr << "fatal: cannot find texture file \"" << textureFile << "\" in textures list" << std::endl;
  exit(-1);
}

void Textures::Write(std::ofstream &output)
{
  unsigned int i;

  // write the texture file names:
  output << "  <textures>" << std::endl;
  for(i=0;i<textureFiles.size();i++) {
    output << "    <texture name=\"TEX" << textureFiles[i] << "\">" << std::endl;
    output << "      <file>textures/" << textureFiles[i] << "</file>" << std::endl;
    output << "    </texture>" << std::endl;
  }
  output << "  </textures>" << std::endl;

  // write the materials:
  output << "  <materials>" << std::endl;
  for(i=0;i<textureFiles.size();i++) {
    output << "    <material name=\"" << textureFiles[i] << "\">" << std::endl;
    output << "      <texture>TEX" << textureFiles[i] << "</texture>" << std::endl;
    output << "    </material>" << std::endl;
  }
  output << "  </materials>" << std::endl;
}

std::string Textures::StripPath(const std::string &file)
{
  int i;
  std::string ret;

  for(i=file.length()-1;i>=0;i--) {
    if(file[i]=='/') {
      ret=file.substr(i+1,file.length()-i);
      break;
    }
  }

  return ret;
}
