#include <sstream>

#include "transnode.h"

void TransformNode::Extract(unsigned int ID)
{
  Variable temp;

  Node::Extract(ID);

  // Read transformation:
  temp=FindVariable(ID,"loc[3]");

  for(int i=0;i<3;i++) {
    translation.X[i]=temp.floatValue[i];
  }

  temp=FindVariable(ID,"rot[3]");
  for(int i=0;i<3;i++) {
    rotation.X[i]=temp.floatValue[i];
  }

  temp=FindVariable(ID,"size[3]");
  for(int i=0;i<3;i++) {
    scale.X[i]=temp.floatValue[i];
  }
}

std::string TransformNode::MakeCoordinateString(Vector a)
{
  std::stringstream buffer;

  buffer << "x=\"" << a.X[0] << "\" y=\"" << a.X[2] << "\" z=\"" << a.X[1] << "\"";

  return buffer.str();
}
