// $Id: AboutDlg.cpp 72 2003-10-24 23:58:51Z felfert $
//
#include "stdafx.h"
#include "aboutDlg.h"
#include "blender2cs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	DWORD dummy;
	DWORD viSize;
	LPVOID vi;
	VS_FIXEDFILEINFO *vsFFI;
	UINT vsFFIlen;
	CBlender2csApp *a = (CBlender2csApp *)AfxGetApp();

	//{{AFX_DATA_INIT(CAboutDlg)
	m_sBlend2csVersion = a->m_sBlend2CsVersion;
	m_sVersion = _T("?.?");
	//}}AFX_DATA_INIT


	viSize = GetFileVersionInfoSize((char *)((LPCSTR)a->m_sExePath), &dummy);
	if (viSize) {
		if ((vi = (LPVOID)malloc(viSize))) {
			if (GetFileVersionInfo((char *)((LPCSTR)a->m_sExePath), dummy, viSize, vi)) {
				if (VerQueryValue(vi, _T("\\"), (LPVOID *)&vsFFI, &vsFFIlen)) {
					CString tmp;
					m_sVersion.Format(_T("%d.%d"),
						HIWORD(vsFFI->dwFileVersionMS),
						LOWORD(vsFFI->dwFileVersionMS));
					if (vsFFI->dwFileVersionLS) {
						tmp.Format(_T(".%d"), HIWORD(vsFFI->dwFileVersionLS));
						m_sVersion += tmp;
					}
					if (LOWORD(vsFFI->dwFileVersionLS)) {
						tmp.Format(_T(".%d"), LOWORD(vsFFI->dwFileVersionLS));
						m_sVersion += tmp;
					}
#ifdef _DEBUG
					m_sVersion += _T(" (DEBUG)");
#else
					m_sVersion += _T(" (RELEASE)");
#endif
				}
			}
			free(vi);
		}
	}
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_STATIC_B2CSVER, m_sBlend2csVersion);
	DDX_Text(pDX, IDC_STATIC_VERSION, m_sVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_STATIC_MAIL, OnStaticMail)
	ON_WM_CTLCOLOR()
	ON_WM_SETCURSOR()
	ON_BN_CLICKED(IDC_STATIC_WEBLINK, OnStaticWeblink)
	ON_BN_CLICKED(IDC_STATIC_GPLLINK, OnStaticGpllink)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CAboutDlg::OnStaticMail() 
{
	CString mailurl = _T("mailto:felfert@to.com?subject=[ABOUT] Blender2Cs%20");

	mailurl += m_sVersion;
	ShellExecute(m_hWnd, _T("open"), mailurl, NULL, NULL, SW_SHOWNORMAL);
}

void CAboutDlg::OnStaticWeblink() 
{
	ShellExecute(m_hWnd, _T("open"),
		_T("http://projects.blender.org/projects/blend2cs"), NULL, NULL, SW_SHOWNORMAL);
}

void CAboutDlg::OnStaticGpllink() 
{
	CString gplrtf = ((CBlender2csApp *)AfxGetApp())->m_sExeDir + _T("\\gpl.rtf");
	ShellExecute(m_hWnd, _T("open"), gplrtf, NULL, NULL, SW_SHOWNORMAL);
}

HBRUSH CAboutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	switch (pWnd->GetDlgCtrlID())
	{
	case IDC_STATIC_MAIL:
	case IDC_STATIC_WEBLINK:
	case IDC_STATIC_GPLLINK:
		pDC->SetTextColor(RGB(0,0,255));
		break;
	case IDC_STATIC_B2CSVER:
		if (m_sBlend2csVersion.Compare(_T("Unknown")) == 0)
			pDC->SetTextColor(RGB(255,0,0));
		break;
	}
	return hbr;
}

BOOL CAboutDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if ((pWnd->GetDlgCtrlID() == IDC_STATIC_MAIL) ||
		(pWnd->GetDlgCtrlID() == IDC_STATIC_WEBLINK) ||
		(pWnd->GetDlgCtrlID() == IDC_STATIC_GPLLINK)) {
		SetCursor(m_hHandCursor);
		return true;
	}
	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_hHandCursor = AfxGetApp()->LoadCursor(IDC_MYHAND);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
