;
; $Id: Installer.iss 86 2003-11-24 00:00:11Z felfert $
;
#ifndef VSCONFIG
#define VSCONFIG	"Release"
#endif

#define APPNAME		"Blender2Cs"
#define APPEXE		VSCONFIG + "\Blender2Cs.exe"

; Automatically get version from executable
#include <version.iss>

; Compress execs with upx
#expr Exec("upx", "--best " + VSCONFIG + "\blender2cs.exe", "", 1, SW_SHOWMINIMIZED)
#expr Exec("upx", "--best ..\blend2cs\blend2cs.exe", "", 1, SW_SHOWMINIMIZED)

[Setup]
AppName={#=APPNAME}
AppVerName={#=APPVERNAME}
AppPublisher=Fritz Elfert
AppVersion={#=APPVERSION}
AppUpdatesURL=http://projects.blender.org/projects/blend2cs
AppSupportURL=mailto:felfert@to.com
OutputDir=Installer
OutputBaseFilename={#=APPNAME}-{#=APPVERSION}-{#=VSCONFIG}-Setup
DefaultDirName={pf}\{#=APPNAME}
DefaultGroupName={#=APPNAME}
DisableStartupPrompt=true
LicenseFile=gpl.rtf
Compression=bzip
AppCopyright= 2003 Fritz Elfert
ShowTasksTreeLines=false
RestartIfNeededByRun=false
DetectLanguageUsingLocale=false
AppID={768FD0F4-39AE-46AD-87E3-512933007660}
ShowLanguageDialog=false
UninstallDisplayIcon={app}\blender2cs.exe

[Messages]
BeveledLabel= 2003 Fritz Elfert

[Types]
Name: compact; Description: Compact installation
Name: full; Description: Full installation
Name: custom; Description: Custom installation; Flags: iscustom

[Components]
Name: main; Description: {#=APPNAME} Program; Types: full compact custom; Flags: fixed
Name: source; Description: {#=APPNAME} Sources; Types: full

[Tasks]
Name: desktopicon; Description: Create a &desktop icon; GroupDescription: Additional icons:
Name: quicklaunchicon; Description: Create a &Quick Launch icon; GroupDescription: Additional icons:; Flags: unchecked

[Files]
Source: {#=VSCONFIG}\blender2cs.exe; DestDir: {app}
Source: ..\blend2cs\blend2cs.exe; DestDir: {app}
Source: ..\Readme; DestDir: {app}
Source: *.rtf; DestDir: {app}
Source: ..\Readme; DestDir: {app}\Source; Components: source
Source: *.cpp; DestDir: {app}\Source\win32; Components: source
Source: *.h; DestDir: {app}\Source\win32; Components: source
Source: *.dsp; DestDir: {app}\Source\win32; Components: source
Source: *.dsw; DestDir: {app}\Source\win32; Components: source
Source: *.clw; DestDir: {app}\Source\win32; Components: source
Source: *.rc; DestDir: {app}\Source\win32; Components: source
Source: *.iss; DestDir: {app}\Source\win32; Components: source
Source: *.txt; DestDir: {app}\Source\win32; Components: source
Source: *.rtf; DestDir: {app}\Source\win32; Components: source
Source: res\*; DestDir: {app}\Source\win32\res; Components: source
Source: ..\blend2cs\*.cpp; DestDir: {app}\Source\blend2cs; Components: source
Source: ..\blend2cs\*.h; DestDir: {app}\Source\blend2cs; Components: source
Source: ..\blend2cs\Makefile; DestDir: {app}\Source\blend2cs; Components: source
Source: ..\blend2cs\Readme; DestDir: {app}\Source\blend2cs; Components: source
Source: ..\blend2cs\configure; DestDir: {app}\Source\blend2cs; Components: source
Source: ..\blend2cs\dna\*; DestDir: {app}\Source\blend2cs\dna; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\dna++\*; DestDir: {app}\Source\blend2cs\dna++; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\doc\*; DestDir: {app}\Source\blend2cs\doc; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\getopt\*; DestDir: {app}\Source\blend2cs\getopt; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\writecs\*; DestDir: {app}\Source\blend2cs\writecs; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\msvc\*.h; DestDir: {app}\Source\blend2cs; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\msvc\*.dsp; DestDir: {app}\Source\blend2cs\msvc; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\msvc\*.dsw; DestDir: {app}\Source\blend2cs\msvc; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\msvc\*.mak; DestDir: {app}\Source\blend2cs\msvc; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\msvc\*.dep; DestDir: {app}\Source\blend2cs\msvc; Components: source; Flags: recursesubdirs
Source: ..\blend2cs\msvc\Readme.txt; DestDir: {app}\Source\blend2cs\msvc; Components: source; Flags: recursesubdirs
Source: ..\blendconv\*; DestDir: {app}\Source\blendconv; Components: source; Flags: recursesubdirs

[Icons]
Name: {group}\{#=APPNAME}; Filename: {app}\Blender2Cs.exe
Name: {group}\Uninstall {#=APPNAME}; Filename: {uninstallexe}
Name: {group}\{#=APPNAME} VC6 Workspace; Filename: {app}\Source\win32\Blender2Cs.dsw; Components: source
Name: {userdesktop}\{#=APPNAME}; Filename: {app}\Blender2Cs.exe; Tasks: desktopicon
Name: {userappdata}\Microsoft\Internet Explorer\Quick Launch\{#=APPNAME}; Filename: {app}\Blender2Cs.exe; Tasks: quicklaunchicon
