// $Id: MsgEdit.cpp 72 2003-10-24 23:58:51Z felfert $
//
// DebugEdit.cpp : implementation file
//

#include "stdafx.h"
#include "MsgEdit.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMsgEdit

static char * rtfInit =
	"{\\rtf1\\ansi\\ansicpg1252\\deff0\\deflang1031{\\fonttbl{\\f0\\fmodern\\fprq1\\fcharset0 Courier New;}}"
	"{\\colortbl ;\\red0\\green0\\blue255;\\red255\\green0\\blue0;}"
	"\\viewkind4\\uc1\\pard\\fs16\\cf0}" ;

DWORD CALLBACK CMsgEdit::InitContent(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
	LONG *idx = (LONG *)dwCookie;
	LONG remaining = strlen(&rtfInit[*idx]);
	LONG count = (remaining > cb) ? cb : remaining;

	memcpy(pbBuff, &rtfInit[*idx], count);
	*idx += count;
	*pcb = count;
	return 0;
}

CMsgEdit::CMsgEdit()
	: CRichEditCtrl()
	, m_nSource(CMsgEdit::SOURCE_OTHER)
	, m_nCurrentColor(0)
{
}

CMsgEdit::~CMsgEdit()
{
}


BEGIN_MESSAGE_MAP(CMsgEdit, CRichEditCtrl)
	//{{AFX_MSG_MAP(CMsgEdit)
	ON_NOTIFY(NM_RCLICK, IDC_RICHEDIT_MSG, OnRclickRicheditMsg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CMsgEdit::SubclassWnd(UINT nId, CWnd *pParent)
{
	return SubclassDlgItem(nId, pParent);
}

/////////////////////////////////////////////////////////////////////////////
// CMsgEdit message handlers

#if 0
HMENU CMsgEdit::GetContextMenu(WORD seltype, LPOLEOBJECT lpoleobj, CHARRANGE* lpchrg)
{
	long firstSel, lastSel;
	int selFlag;
	int hasTextFlag;
	CString strMenu;
	CMenu m;

	GetSel(firstSel, lastSel);
	selFlag = (lastSel != firstSel) ? 0 : MF_GRAYED;
	hasTextFlag = GetWindowTextLength() ? 0 : MF_GRAYED;

	m.CreatePopupMenu();

	strMenu.LoadString(IDS_EDIT_UNDO);
	if (!strMenu.IsEmpty()) {
		m.AppendMenu(MF_STRING|(CanUndo() ? 0 : MF_GRAYED), IDM_EDIT_UNDO, strMenu);
		m.AppendMenu(MF_SEPARATOR);
	}
	strMenu.LoadString(IDS_EDIT_CUT);
	if (!strMenu.IsEmpty())
		m.AppendMenu(MF_STRING|selFlag, IDM_EDIT_CUT, strMenu);
	strMenu.LoadString(IDS_EDIT_COPY);
	if (!strMenu.IsEmpty())
		m.AppendMenu(MF_STRING|selFlag, IDM_EDIT_COPY, strMenu);
	strMenu.LoadString(IDS_EDIT_PASTE);
	if (!strMenu.IsEmpty())
		m.AppendMenu(MF_STRING|CanPaste() ? 0 : MF_GRAYED, IDM_EDIT_PASTE, strMenu);
	strMenu.LoadString(IDS_EDIT_DELETE);
	if (!strMenu.IsEmpty())
		m.AppendMenu(MF_STRING|selFlag, IDM_EDIT_DELETE, strMenu);
	strMenu.LoadString(IDS_EDIT_SALL);
	if (!strMenu.IsEmpty()) {
		m.AppendMenu(MF_SEPARATOR);
		m.AppendMenu(MF_STRING|hasTextFlag, IDM_EDIT_SALL, strMenu);
	}
	strMenu.LoadString(IDS_EDIT_CLEAR);
	if (!strMenu.IsEmpty())
		m.AppendMenu(MF_STRING|hasTextFlag, IDM_EDIT_CLEAR, strMenu);
	strMenu.LoadString(IDS_ABOUTBOX);
	if (!strMenu.IsEmpty())
		m.AppendMenu(MF_STRING, IDM_ABOUTBOX, strMenu);
	strMenu.LoadString(IDS_EDIT_EXIT);
	if (!strMenu.IsEmpty()) {
		m.AppendMenu(MF_SEPARATOR);
		m.AppendMenu(MF_STRING, IDM_EXIT, strMenu);
	}

	return m.Detach();
}
#endif

BOOL CMsgEdit::OnCommand(WPARAM wParam, LPARAM lParam)
{
	DWORD cmd = LOWORD(wParam);

	if (HIWORD(wParam) == 0) {
		switch (cmd) {
			case IDM_EDIT_UNDO:
				Undo();
				return TRUE;
			case IDM_EDIT_CUT:
				Cut();
				return TRUE;
			case IDM_EDIT_PASTE:
				Paste();
				return TRUE;
			case IDM_EDIT_COPY:
				Copy();
				return TRUE;
			case IDM_EDIT_SALL:
				SetSel(0,-1);
				return TRUE;
			case IDM_EDIT_CLEAR:
				SetWindowText("");
				return TRUE;
			case IDM_EDIT_DELETE:
				ReplaceSel("", TRUE);
				return TRUE;
			case IDM_ABOUTBOX:
			case IDM_EXIT:
				AfxGetMainWnd()->PostMessage(WM_SYSCOMMAND, LOWORD(wParam), 0);
				return TRUE;
			default:
				switch (HIBYTE(cmd)) {
				case (HIBYTE(IDM_EDIT_INSERT_COUT)):
					m_nSource = SOURCE_COUT;
					SendMessage(WM_CHAR, LOBYTE(cmd), 0);
					return TRUE;
				case (HIBYTE(IDM_EDIT_INSERT_CERR)):
					m_nSource = SOURCE_CERR;
					SendMessage(WM_CHAR, LOBYTE(cmd), 0);
					return TRUE;
				case (HIBYTE(IDM_EDIT_INSERT_NOTE)):
					m_nSource = SOURCE_NOTE;
					SendMessage(WM_CHAR, LOBYTE(cmd), 0);
					return TRUE;
				}
				break;

		}
	}
	// TODO: Add your specialized code here and/or call the base class

	return CRichEditCtrl::OnCommand(wParam, lParam);
}

void CMsgEdit::PreSubclassWindow()
{
	CRichEditCtrl::PreSubclassWindow();

	EDITSTREAM es;
	DWORD idx = 0;

	es.dwCookie = (DWORD) &idx;
	es.pfnCallback = InitContent;
	StreamIn(SF_RTF, es);
}

void CMsgEdit::SetColor(COLORREF color)
{
	if (m_nCurrentColor != color) {
		CHARFORMAT cf;

		GetSelectionCharFormat(cf);
		cf.dwMask = CFM_COLOR;
		cf.dwEffects = NULL;
		cf.crTextColor = color;
		SetSelectionCharFormat(cf);
		m_nCurrentColor = color;
	}
}

void CMsgEdit::OnRclickRicheditMsg(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}
