// $Id: blender2cs.cpp 72 2003-10-24 23:58:51Z felfert $
//
// blender2cs.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "blender2cs.h"
#include "blender2csDlg.h"
#include "ExternalExec.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBlender2csApp

BEGIN_MESSAGE_MAP(CBlender2csApp, CWinApp)
	//{{AFX_MSG_MAP(CBlender2csApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlender2csApp construction

static BOOL myOutCallback(LPVOID ptr, BOOL isErr, const char *line)
{
	CString tmp = line;

	tmp = tmp.Mid(16);
	tmp.TrimLeft();
	tmp.TrimRight();
	((CBlender2csApp *)ptr)->m_sBlend2CsVersion = tmp;
	return TRUE;
}

CBlender2csApp::CBlender2csApp()
{
	BOOL ok;
	DWORD xcode;
	char exebuf[MAX_PATH];

	GetModuleFileName(NULL, exebuf, sizeof(exebuf));
	m_sExePath = exebuf;
	m_sExeDir = exebuf;
	m_sExeDir = m_sExeDir.Left(m_sExeDir.ReverseFind(TCHAR('\\')));
	m_sBlend2CsVersion = _T("Unknown");

	// Get blend2cs version, executable expected in same directory like blend2cs,
	// or (for debugging from within Visual Studio) in ..\..\blend2cs\.
	ExternalExec e;

	e.SetCallBack(myOutCallback);
	m_sBlend2CsExecutable = m_sExeDir + _T("\\blend2cs.exe");
	e.AddProcess(m_sBlend2CsExecutable, _T("-v"), NULL, SW_HIDE);
	ok = e.Run(this);
#ifdef _DEBUG
	if (!ok) {
		e.Clear();
		e.SetCallBack(myOutCallback);
		m_sBlend2CsExecutable = m_sExeDir + _T("\\..\\..\\blend2cs\\blend2cs.exe");
		e.AddProcess(m_sBlend2CsExecutable, _T("-v"), NULL, SW_HIDE);
		ok = e.Run(this);
	}
#endif
	xcode = e.ExitCode(); // blocks, until blend2cs returned
	if ((!ok) || xcode)
		m_sBlend2CsExecutable = "";
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBlender2csApp object

CBlender2csApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBlender2csApp initialization

BOOL CBlender2csApp::InitInstance()
{
	SetRegistryKey(_T("felfert")); // Resulting key is HKCU/Software/felfert/Blender2Cs
	AfxEnableControlContainer();
	AfxInitRichEdit( );

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	if (m_sBlend2CsExecutable.IsEmpty()) {
		AfxMessageBox(IDS_ERR_NOBLEXE);
	} else {
		CBlender2csDlg dlg;
		m_pMainWnd = &dlg;
		dlg.DoModal();
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
