/********************************************************************
**                                                                 **
**  Blender File          author: celer                            **
**  Library               email: celer@scrypt.net                  **
**                        Copywrite (C) 2000 by David Tyree.       **
**                        All rights reserved.                     **
*********************************************************************
* This library is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU Library General Public       *
* License as published by the Free Software Foundation; either      *
* version 2 of the License, or (at your option) any later version.  *
*                                                                   *
* This library is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *
* Library General Public License for more details.                  *
*                                                                   *
* You should have received a copy of the GNU Library General Public *
* License along with this library; if not, write to the Free        *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.*
*********************************************************************
$Id: bfile.c 62 2003-09-30 13:56:49Z matzebraun $
********************************************************************/ 
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

#include "btypes.h"
#include "bfile.h"
#include "bdata.h"
#include "butil.h"

BLFile *BLOpenFile(const char *name){
	BLFile *mFile=BLNewFileData();	
	struct stat mFileData;
	
	mFile->file=fopen(name,"rb");
	if(!mFile->file)
		return NULL;
	
	if(stat(name,&mFileData)!=0)
			return NULL;
	
	mFile->file_size=mFileData.st_size;
	
	return mFile;
}


void BLCloseFile(BLFile *file){
	fclose(file->file);
	BLDeleteFileData(file);
}

