/********************************************************************
**                                                                 **
**  Blender File          author: celer                            **
**  Library               email: celer@scrypt.net                  **
**                        Copywrite (C) 2000 by David Tyree.       **
**                        All rights reserved.                     **
*********************************************************************
* This library is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU Library General Public       *
* License as published by the Free Software Foundation; either      *
* version 2 of the License, or (at your option) any later version.  *
*                                                                   *
* This library is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *
* Library General Public License for more details.                  *
*                                                                   *
* You should have received a copy of the GNU Library General Public *
* License along with this library; if not, write to the Free        *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.*
*********************************************************************
$Id: butil.c 11 2003-01-05 22:27:27Z gmueckl $
********************************************************************/ 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "btypes.h"
#include "bfile.h"
#include "bdata.h"
#include "butil.h"

BLFile *BLNewFileData(){
	BLFile *mFile;
	mFile=(BLFile *) malloc(sizeof(BLFile));
		if(!mFile)
			return NULL;
	memset(mFile,0,sizeof(BLFile));
	return mFile;
}

void BLDeleteFileData(BLFile *file){
	BLFreeStructs(file->struct_head);
	free(file);
}



uint16 swap2(uint16 a){
	uint8 temp[2];
	uint8 *acast=(uint8 *) &a;
	uint16 *bcast=(uint16 *) &temp;
	temp[0]=acast[1];
	temp[1]=acast[0];
	return (uint16) *bcast;
}	

uint32 swap4(uint32 a){
	uint8 temp[4];
	uint8 *acast=(uint8 * ) &a;
	uint32 *bcast=(uint32 *) &temp;
	temp[0]=acast[3];
	temp[1]=acast[2];
	temp[2]=acast[1];
	temp[3]=acast[0];
	return (uint16) *bcast;
}

uint64 swap8(uint64 a){
	uint8 temp[8];
	uint8 *acast=(uint8 *) &a;
	uint64 *bcast=(uint64 *) &temp;
	temp[0]=acast[7];
	temp[1]=acast[6];
	temp[2]=acast[5];
	temp[3]=acast[4];
	temp[4]=acast[3];
	temp[5]=acast[2];
	temp[6]=acast[1];
	temp[7]=acast[0];
	return (uint16) *bcast;
}
